#include "mp3player.h" 
#include "at32f403a_407_board.h"
#include "key.h"		 
#include "malloc.h"
#include "text.h"
#include "string.h"
#include "exfuns.h"  
#include "ff.h"   
#include "usart.h"	
#include "play.h"

u32 frame_count2 = 0;
extern vu8 g_next;
extern vu8 g_pervious;

//õpath·,Ŀļܸ
//path:·		    
//ֵ:Чļ
u16 mp3_get_tnum(u8 *path)
{	  
	u8 res;
	u16 rval=0;
 	DIR tdir;	 		//ʱĿ¼
	FILINFO tfileinfo;	//ʱļϢ		
	u8 *fn; 			 			   			     
    res=f_opendir(&tdir,(const TCHAR*)path); //Ŀ¼
  	tfileinfo.lfsize=_MAX_LFN*2+1;						//ļ󳤶
	tfileinfo.lfname=mymalloc(SRAMIN,tfileinfo.lfsize);	//Ϊļڴ
	if(res==FR_OK&&tfileinfo.lfname!=NULL)
	{
		while(1)//ѯܵЧļ
		{
	        res=f_readdir(&tdir,&tfileinfo);       		//ȡĿ¼µһļ
	        if(res!=FR_OK||tfileinfo.fname[0]==0)break;	///ĩβ,˳		  
     		fn=(u8*)(*tfileinfo.lfname?tfileinfo.lfname:tfileinfo.fname);			 
			res=f_typetell(fn);	
			if((res&0XF0)==0X40)//ȡλ,ǲļ	
			{
				rval++;//Чļ1
			}	    
		}  
	} 
	myfree(SRAMIN,tfileinfo.lfname);
	return rval;
}
//
void mp3_play(void)
{
	u8 res;
 	DIR mp3dir;	 		//Ŀ¼
	FILINFO mp3fileinfo;//ļϢ
	u8 *fn;   			//ļ
	u8 *pname;			//·ļ
	u16 totmp3num; 		//ļ
	u16 curindex;		//ͼƬǰ	  
 	u16 temp;
	u16 *mp3indextbl;	// 
 	while(f_opendir(&mp3dir,"0:/MUSIC"))//ͼƬļ
 	{	    
		printf("MUSICļд!\r\n");
		delay_ms(200);			  
	} 									  
	totmp3num=mp3_get_tnum("0:/MUSIC"); //õЧļ
  	while(totmp3num==NULL)//ļΪ0		
 	{	    
		printf("ûļ!\r\n");
		delay_ms(200);			  
	}										   
  	mp3fileinfo.lfsize=_MAX_LFN*2+1;						//ļ󳤶
	mp3fileinfo.lfname=mymalloc(SRAMIN,mp3fileinfo.lfsize);	//Ϊļڴ
 	pname=mymalloc(SRAMIN,mp3fileinfo.lfsize);				//Ϊ·ļڴ
 	mp3indextbl=mymalloc(SRAMIN,2*totmp3num);				//2*totmp3numֽڵڴ,ڴļ
 	while(mp3fileinfo.lfname==NULL||pname==NULL||mp3indextbl==NULL)//ڴ
 	{	    
		printf("ڴʧ!\r\n");
		delay_ms(200);			  
	}
  
	//¼
  res=f_opendir(&mp3dir,"0:/MUSIC"); //Ŀ¼
	if(res==FR_OK)
	{
		curindex=0;//ǰΪ0
		while(1)//ȫѯһ
		{
			temp=mp3dir.index;								//¼ǰindex
	        res=f_readdir(&mp3dir,&mp3fileinfo);       		//ȡĿ¼µһļ
	        if(res!=FR_OK||mp3fileinfo.fname[0]==0)break;	///ĩβ,˳		  
     		fn=(u8*)(*mp3fileinfo.lfname?mp3fileinfo.lfname:mp3fileinfo.fname);			 
			res=f_typetell(fn);	
			if((res&0XF0)==0X40)//ȡλ,ǲļ	
			{
				mp3indextbl[curindex]=temp;//¼
				curindex++;
			}	    
		} 
	}   
   	curindex=0;											//0ʼʾ
   	res=f_opendir(&mp3dir,(const TCHAR*)"0:/MUSIC"); 	//Ŀ¼
	while(res==FR_OK)//򿪳ɹ
	{	
		dir_sdi(&mp3dir,mp3indextbl[curindex]);			//ı䵱ǰĿ¼	   
        res=f_readdir(&mp3dir,&mp3fileinfo);       		//ȡĿ¼µһļ
        if(res!=FR_OK||mp3fileinfo.fname[0]==0)break;	///ĩβ,˳
     	fn=(u8*)(*mp3fileinfo.lfname?mp3fileinfo.lfname:mp3fileinfo.fname);		
		strcpy((char*)pname,"0:/MUSIC/");				//·(Ŀ¼)
		strcat((char*)pname,(const char*)fn);  			//ļں    
//		printf("0:/MUSIC/%s", fn);				//ʾ 
		res=mp3_play_song(pname); 				 		//MP3    /**************************************************************/
		if(g_pervious)		//һ
		{
      g_pervious = 0;
			if(curindex)curindex--;
			else curindex=totmp3num-1;
 		}else if(g_next)//һ
		{
      g_next = 0;
			curindex++;		   	
			if(curindex>=totmp3num)curindex=0;//ĩβʱ,Զͷʼ
 		}else
    {
      curindex++;		   	
			if(curindex>=totmp3num)curindex=0;//ĩβʱ,Զͷʼ
    }
	} 											  
	myfree(SRAMIN,mp3fileinfo.lfname);	//ͷڴ			    
	myfree(SRAMIN,pname);				//ͷڴ			    
	myfree(SRAMIN,mp3indextbl);			//ͷڴ	 
}

//һָĸ				     	   									    	 
//ֵ:0,
//		 1,һ
//       2,һ
//       0XFF,ִ
u8 mp3_play_song(u8 *pname)
{	 
 	FIL* fmp3;
	u8 res,rval;
  int Status;
	u8 *databuf;    
			   
	rval=0;	    
	fmp3=(FIL*)mymalloc(SRAMIN,sizeof(FIL));//ڴ
	databuf=(u8*)mymalloc(SRAMIN,4096);		//4096ֽڵڴ
	if(databuf==NULL||fmp3==NULL)rval=0XFF ;//ڴʧ.
	if(rval==0)
	{	  
//	  	VS_Restart_Play();  					// 
//		VS_Set_All();        					//Ϣ 			 
//		VS_Reset_DecodeTime();					//λʱ 	  
		res=f_typetell(pname);	 	 			//õļ׺	 			  	 						 
 				 		   		 						  
		res=f_open(fmp3,(const TCHAR*)pname,FA_READ);//ļ	 
 		if(res==0)//򿪳ɹ.
		{ 
      printf("begin to decode %s\r\n",pname);
      /* Decode stdin to stdout. */
      Status=MpegAudioDecoder(fmp3);
      printf("end decode %s\r\n", pname);
//      printf("frame_count2 = %d\r\n", frame_count2);
      if(Status) 
      {
        printf("an error occurred during decoding %s.\n", pname);
      }
			f_close(fmp3);
		}else rval=0XFF;//ִ	   	  
	}						     	 
	myfree(SRAMIN,databuf);	  	 		  	    
	myfree(SRAMIN,fmp3);
	return rval;	  	 		  	    
}
