#include "at32f403a_407.h"
#include "key.h"
#include "sys.h" 
#include "at32f403a_407_board.h"
								    
//ʼ
void KEY_Init(void) //IOʼ
{ 
  gpio_init_type  gpio_init_structure;
  exint_init_type exint_init_structure;
 
 	crm_periph_clock_enable(CRM_GPIOC_PERIPH_CLOCK,TRUE);//ʹPORTA,PORTEʱ
 	crm_periph_clock_enable(CRM_IOMUX_PERIPH_CLOCK,TRUE);

  gpio_default_para_init(&gpio_init_structure);
  gpio_init_structure.gpio_pins = GPIO_PINS_13 | GPIO_PINS_0;
  gpio_init_structure.gpio_mode = GPIO_MODE_INPUT;
  gpio_init_structure.gpio_pull = GPIO_PULL_DOWN;
  gpio_init_structure.gpio_drive_strength =  GPIO_DRIVE_STRENGTH_STRONGER;
  gpio_init(GPIOC, &gpio_init_structure);

    /* Connect EXTI0 Line to PA.00 pin */
  gpio_exint_line_config(GPIO_PORT_SOURCE_GPIOC, GPIO_PINS_SOURCE0);
  gpio_exint_line_config(GPIO_PORT_SOURCE_GPIOC, GPIO_PINS_SOURCE13);

  /* Configure EXTI0 line */
  exint_init_structure.line_select = EXINT_LINE_0;
  exint_init_structure.line_mode = EXINT_LINE_INTERRUPUT;
  exint_init_structure.line_polarity = EXINT_TRIGGER_RISING_EDGE;
  exint_init_structure.line_enable = TRUE;
  exint_init(&exint_init_structure);
  
  exint_init_structure.line_select = EXINT_LINE_13;
  exint_init(&exint_init_structure);

  /* Enable and set EXTI0 Interrupt to the lowest priority */
  nvic_irq_enable(EXINT0_IRQn, 0, 0);
  nvic_irq_enable(EXINT15_10_IRQn, 0, 3);
}

//
//ذֵ
//mode:0,֧;1,֧;
//0ûκΰ
//1KEY0
//2KEY1
//3KEY2 
//4KEY3 WK_UP
//ע˺Ӧȼ,KEY0>KEY1>KEY2>KEY3!!
u8 KEY_Scan(u8 mode)
{	 
	static u8 key_up=1;//ɿ־
	if(mode)key_up=1;  //֧		  
	if(key_up&&(KEY0==0||KEY1==0||KEY2==0||WK_UP==1))
	{
		delay_ms(10);//ȥ 
		key_up=0;
		if(KEY0==0)return KEY0_PRES;
		else if(KEY1==0)return KEY1_PRES;
		else if(KEY2==0)return KEY2_PRES;
		else if(WK_UP==1)return WKUP_PRES;
	}else if(KEY0==1&&KEY1==1&&KEY2==1&&WK_UP==0)key_up=1; 	    
 	return 0;// ް
}
