#include "spi.h"
 
//SPIģĳʼ룬óģʽSD Card/W25Q64/NRF24L01						  
//SPIڳʼ
//ǶSPI2ĳʼ



void SPI2_Init(void)
{
  gpio_init_type  GPIO_InitStructure;
  spi_init_type  SPI_InitStructure;

  crm_periph_clock_enable(CRM_GPIOB_PERIPH_CLOCK, TRUE);//PORTBʱʹ 
	crm_periph_clock_enable(CRM_SPI2_PERIPH_CLOCK,  TRUE );//SPI2ʱʹ 	
 
  gpio_default_para_init(&GPIO_InitStructure);
  GPIO_InitStructure.gpio_pins = GPIO_PINS_13 | GPIO_PINS_14 | GPIO_PINS_15;
  GPIO_InitStructure.gpio_mode = GPIO_MODE_MUX;
  GPIO_InitStructure.gpio_out_type = GPIO_OUTPUT_PUSH_PULL;
  GPIO_InitStructure.gpio_drive_strength =  GPIO_DRIVE_STRENGTH_STRONGER;
  gpio_init(GPIOB, &GPIO_InitStructure);

  gpio_bits_set(GPIOB, GPIO_PINS_13 | GPIO_PINS_14 | GPIO_PINS_15);  //PB13/14/15

  spi_default_para_init(&SPI_InitStructure);
  SPI_InitStructure.transmission_mode = SPI_TRANSMIT_FULL_DUPLEX;
  SPI_InitStructure.master_slave_mode = SPI_MODE_MASTER;
  SPI_InitStructure.mclk_freq_division = SPI_MCLK_DIV_256;
  SPI_InitStructure.first_bit_transmission = SPI_FIRST_BIT_MSB;
  SPI_InitStructure.frame_bit_num = SPI_FRAME_8BIT;
  SPI_InitStructure.clock_polarity = SPI_CLOCK_POLARITY_HIGH;
  SPI_InitStructure.clock_phase = SPI_CLOCK_PHASE_2EDGE;
  SPI_InitStructure.cs_mode_selection = SPI_CS_SOFTWARE_MODE;
  spi_init(SPI2, &SPI_InitStructure);
  spi_crc_polynomial_set(SPI2, 7);
   
	spi_enable(SPI2, TRUE); //ʹSPI
	
	SPI2_ReadWriteByte(0xff);//		 
 

}   
//SPI ٶú
//SpeedSet:
//SPI_BaudRatePrescaler_2   2Ƶ   
//SPI_BaudRatePrescaler_8   8Ƶ   
//SPI_BaudRatePrescaler_16  16Ƶ  
//SPI_BaudRatePrescaler_256 256Ƶ 
  
void SPI2_SetSpeed(u8 SPI_BaudRatePrescaler)
{
//  assert_param(IS_SPI_BAUDRATE_PRESCALER(SPI_BaudRatePrescaler));
	SPI2->ctrl1&=0XFFC7;
	SPI2->ctrl1|=SPI_BaudRatePrescaler;	//SPI2ٶ 
	spi_enable(SPI2,TRUE); 

} 

//SPIx дһֽ
//TxData:Ҫдֽ
//ֵ:ȡֽ
u8 SPI2_ReadWriteByte(u8 TxData)
{		
	u8 retry=0;				 	
	while (spi_i2s_flag_get(SPI2, SPI_I2S_TDBE_FLAG) == RESET) //ָSPI־λ:ͻձ־λ
		{
		retry++;
		if(retry>200)return 0;
		}			  
	spi_i2s_flag_get(SPI2, TxData); //ͨSPIxһ
	retry=0;

	while (spi_i2s_flag_get(SPI2, SPI_I2S_RDBF_FLAG) == RESET)//ָSPI־λ:ܻǿձ־λ
		{
		retry++;
		if(retry>200)return 0;
		}	  						    
	return spi_i2s_data_receive(SPI2); //ͨSPIxյ					    
}





























