#ifndef __MALLOC_H
#define __MALLOC_H
#include "at32f403a_407.h" 
 
#ifndef NULL
#define NULL 0
#endif

//ڴ
#define SRAMIN	 0		//ڲڴ
#define SRAMEX   1		//ⲿڴ 

#define SRAMBANK 	2	//ֵ֧SRAM.	


//mem1ڴ趨.mem1ȫڲSRAM.
#define MEM1_BLOCK_SIZE			32  	  						//ڴСΪ32ֽ
#define MEM1_MAX_SIZE			20*1024  						//ڴ 40K
#define MEM1_ALLOC_TABLE_SIZE	MEM1_MAX_SIZE/MEM1_BLOCK_SIZE 	//ڴС

//mem2ڴ趨.mem2ڴشⲿSRAM
#define MEM2_BLOCK_SIZE			32  	  						//ڴСΪ32ֽ
#define MEM2_MAX_SIZE			480 *1024  						//ڴ960K
#define MEM2_ALLOC_TABLE_SIZE	MEM2_MAX_SIZE/MEM2_BLOCK_SIZE 	//ڴС 
		 
 
//ڴ
struct _m_mallco_dev
{
	void (*init)(u8);					//ʼ
	u8 (*perused)(u8);		  	    	//ڴʹ
	u8 	*membase[SRAMBANK];				//ڴ SRAMBANKڴ
	u16 *memmap[SRAMBANK]; 				//ڴ״̬
	u8  memrdy[SRAMBANK]; 				//ڴǷ
};
extern struct _m_mallco_dev mallco_dev;	 //mallco.c涨

void mymemset(void *s,u8 c,u32 count);	//ڴ
void mymemcpy(void *des,void *src,u32 n);//ڴ     
void my_mem_init(u8 memx);				//ڴʼ(/ڲ)
u32 my_mem_malloc(u8 memx,u32 size);	//ڴ(ڲ)
u8 my_mem_free(u8 memx,u32 offset);		//ڴͷ(ڲ)
u8 my_mem_perused(u8 memx);				//ڴʹ(/ڲ) 
////////////////////////////////////////////////////////////////////////////////
//ûú
void myfree(u8 memx,void *ptr);  			//ڴͷ(ⲿ)
void *mymalloc(u8 memx,u32 size);			//ڴ(ⲿ)
void *myrealloc(u8 memx,void *ptr,u32 size);//·ڴ(ⲿ)
#endif













