#include "sys.h"
#include "usart.h"
#include "key.h"
#include "malloc.h"
#include "at32_sdio.h"
#include "w25qxx.h"
#include "ff.h"
#include "exfuns.h"
#include "text.h"
#include "mp3player.h"
#include "at32_audio_conf.h"
#include "wm8988_i2s.h"
#include "at32f403a_407_board.h"
#include "at32f403a_407_clock.h"

int main(void)
{
  system_clock_config();
  delay_init();	    	 //ʱʼ
  uart_init(115200);	 	//ڳʼΪ115200
  KEY_Init();					//ʼ

  my_mem_init(SRAMIN);		//ʼڲڴ
  exfuns_init();				//Ϊfatfsرڴ
  f_mount(fs[0], "0:", 1); 		//SD
  f_mount(fs[1], "1:", 1); 		//FLASH.

  if ( Audio_Init(AT32_AUDIO_FREQ_44K, AT32_AUDIO_BITW_16) != AUDIO_OK )
  {
    /*WM8988 init Failed*/
    printf("WM8988 init Failed!\r\n");
  }

  while(1)
  {
    delay_ms(200);
    mp3_play();
  }
}
