#include "fontupd.h"
#include "ff.h"	  
#include "w25qxx.h"    
#include "string.h"
#include "malloc.h"
#include "at32f403a_407_board.h"
#include "usart.h" 

//ֿռõС(3ֿ+unigbk+ֿϢ=3238700ֽ,Լռ791W25QXX)
#define FONTSECSIZE	 	791
//ֿʼַ 
#define FONTINFOADDR 	1024*1024*12 					//WarShip STM32F103 V3Ǵ12MַԺʼֿ
														//ǰ12Mfatfsռ.
														//12MԺ3ֿ+UNIGBK.BIN,ܴС3.09M,ֿռ,ܶ!
														//15.10MԺ,ûʹ.100KֽڱȽϺ.
														
//ֿϢַС
_font_info ftinfo;

//ֿڴе·
u8*const GBK24_PATH="/SYSTEM/FONT/GBK24.FON";		//GBK24Ĵλ
u8*const GBK16_PATH="/SYSTEM/FONT/GBK16.FON";		//GBK16Ĵλ
u8*const GBK12_PATH="/SYSTEM/FONT/GBK12.FON";		//GBK12Ĵλ
u8*const UNIGBK_PATH="/SYSTEM/FONT/UNIGBK.BIN";		//UNIGBK.BINĴλ

//ʾǰ½
//x,y:
//size:С
//fsize:ļС
//pos:ǰļָλ
u32 fupd_prog(u16 x,u16 y,u8 size,u32 fsize,u32 pos)
{
	float prog;
	u8 t=0XFF;
	prog=(float)pos/fsize;
	prog*=100;
	if(t!=prog)
	{
//		LCD_ShowString(x+3*size/2,y,240,320,size,"%");		
		t=prog;
		if(t>100)t=100;
//		LCD_ShowNum(x,y,t,3,size);//ʾֵ
	}
	return 0;					    
} 
//ĳһ
//x,y:
//size:С
//fxpath:·
//fx:µ 0,ungbk;1,gbk12;2,gbk16;3,gbk24;
//ֵ:0,ɹ;,ʧ.
u8 updata_fontx(u16 x,u16 y,u8 size,u8 *fxpath,u8 fx)
{
	u32 flashaddr=0;								    
	FIL * fftemp;
	u8 *tempbuf;
 	u8 res;	
	u16 bread;
	u32 offx=0;
	u8 rval=0;	     
	fftemp=(FIL*)mymalloc(SRAMIN,sizeof(FIL));	//ڴ	
	if(fftemp==NULL)rval=1;
	tempbuf=mymalloc(SRAMIN,4096);				//4096ֽڿռ
	if(tempbuf==NULL)rval=1;
 	res=f_open(fftemp,(const TCHAR*)fxpath,FA_READ); 
 	if(res)rval=2;//ļʧ  
 	if(rval==0)	 
	{
		switch(fx)
		{
			case 0:												//UNIGBK.BIN
				ftinfo.ugbkaddr=FONTINFOADDR+sizeof(ftinfo);	//Ϣͷ֮󣬽UNIGBKת
				ftinfo.ugbksize=fftemp->fsize;					//UNIGBKС
				flashaddr=ftinfo.ugbkaddr;
				break;
			case 1:
				ftinfo.f12addr=ftinfo.ugbkaddr+ftinfo.ugbksize;	//UNIGBK֮󣬽GBK12ֿ
				ftinfo.gbk12size=fftemp->fsize;					//GBK12ֿС
				flashaddr=ftinfo.f12addr;						//GBK12ʼַ
				break;
			case 2:
				ftinfo.f16addr=ftinfo.f12addr+ftinfo.gbk12size;	//GBK12֮󣬽GBK16ֿ
				ftinfo.gbk16size=fftemp->fsize;					//GBK16ֿС
				flashaddr=ftinfo.f16addr;						//GBK16ʼַ
				break;
			case 3:
				ftinfo.f24addr=ftinfo.f16addr+ftinfo.gbk16size;	//GBK16֮󣬽GBK24ֿ
				ftinfo.gkb24size=fftemp->fsize;					//GBK24ֿС
				flashaddr=ftinfo.f24addr;						//GBK24ʼַ
				break;
		} 
			
		while(res==FR_OK)//ѭִ
		{
	 		res=f_read(fftemp,tempbuf,4096,(UINT *)&bread);		//ȡ	 
			if(res!=FR_OK)break;								//ִд
			W25QXX_Write(tempbuf,offx+flashaddr,4096);		//0ʼд4096  
	  		offx+=bread;	  
			fupd_prog(x,y,size,fftemp->fsize,offx);	 			//ʾ
			if(bread!=4096)break;								//.
	 	} 	
		f_close(fftemp);		
	}			 
	myfree(SRAMIN,fftemp);	//ͷڴ
	myfree(SRAMIN,tempbuf);	//ͷڴ
	return res;
} 
//ļ,UNIGBK,GBK12,GBK16,GBK24һ
//x,y:ʾϢʾַ
//size:С
//src:ֿԴ."0:",SD;"1:",FLASH,"2:",U.
//ʾϢС										  
//ֵ:0,³ɹ;
//		 ,.	  
u8 update_font(u16 x,u16 y,u8 size,u8* src)
{	
	u8 *pname;
	u32 *buf;
	u8 res=0;		   
 	u16 i,j;
	FIL *fftemp;
	u8 rval=0; 
	res=0XFF;		
	ftinfo.fontok=0XFF;
	pname=mymalloc(SRAMIN,100);	//100ֽڴ  
	buf=mymalloc(SRAMIN,4096);	//4Kֽڴ  
	fftemp=(FIL*)mymalloc(SRAMIN,sizeof(FIL));	//ڴ	
	if(buf==NULL||pname==NULL||fftemp==NULL)
	{
		myfree(SRAMIN,fftemp);
		myfree(SRAMIN,pname);
		myfree(SRAMIN,buf);
		return 5;	//ڴʧ
	}
	//ȲļǷ 
	strcpy((char*)pname,(char*)src);	//copy srcݵpname
	strcat((char*)pname,(char*)UNIGBK_PATH); 
 	res=f_open(fftemp,(const TCHAR*)pname,FA_READ); 
 	if(res)rval|=1<<4;//ļʧ  
	strcpy((char*)pname,(char*)src);	//copy srcݵpname
	strcat((char*)pname,(char*)GBK12_PATH); 
 	res=f_open(fftemp,(const TCHAR*)pname,FA_READ); 
 	if(res)rval|=1<<5;//ļʧ  
	strcpy((char*)pname,(char*)src);	//copy srcݵpname
	strcat((char*)pname,(char*)GBK16_PATH); 
 	res=f_open(fftemp,(const TCHAR*)pname,FA_READ); 
 	if(res)rval|=1<<6;//ļʧ  
	strcpy((char*)pname,(char*)src);	//copy srcݵpname
	strcat((char*)pname,(char*)GBK24_PATH); 
 	res=f_open(fftemp,(const TCHAR*)pname,FA_READ); 
 	if(res)rval|=1<<7;//ļʧ   
	myfree(SRAMIN,fftemp);//ͷڴ
	if(rval==0)//ֿļ.
	{  
//		LCD_ShowString(x,y,240,320,size,"Erasing sectors... ");//ʾڲ	
		for(i=0;i<FONTSECSIZE;i++)	//Ȳֿ,дٶ
		{
			fupd_prog(x+20*size/2,y,size,FONTSECSIZE,i);//ʾ
			W25QXX_Read((u8*)buf,((FONTINFOADDR/4096)+i)*4096,4096);//
			for(j=0;j<1024;j++)//У
			{
				if(buf[j]!=0XFFFFFFFF)break;//Ҫ  	  
			}
			if(j!=1024)W25QXX_Erase_Sector((FONTINFOADDR/4096)+i);	//Ҫ
		}
		myfree(SRAMIN,buf);
//		LCD_ShowString(x,y,240,320,size,"Updating UNIGBK.BIN");		
		strcpy((char*)pname,(char*)src);				//copy srcݵpname
		strcat((char*)pname,(char*)UNIGBK_PATH); 
		res=updata_fontx(x+20*size/2,y,size,pname,0);	//UNIGBK.BIN
		if(res){myfree(SRAMIN,pname);return 1;}
//		LCD_ShowString(x,y,240,320,size,"Updating GBK12.BIN  ");
		strcpy((char*)pname,(char*)src);				//copy srcݵpname
		strcat((char*)pname,(char*)GBK12_PATH); 
		res=updata_fontx(x+20*size/2,y,size,pname,1);	//GBK12.FON
		if(res){myfree(SRAMIN,pname);return 2;}
//		LCD_ShowString(x,y,240,320,size,"Updating GBK16.BIN  ");
		strcpy((char*)pname,(char*)src);				//copy srcݵpname
		strcat((char*)pname,(char*)GBK16_PATH); 
		res=updata_fontx(x+20*size/2,y,size,pname,2);	//GBK16.FON
		if(res){myfree(SRAMIN,pname);return 3;}
//		LCD_ShowString(x,y,240,320,size,"Updating GBK24.BIN  ");
		strcpy((char*)pname,(char*)src);				//copy srcݵpname
		strcat((char*)pname,(char*)GBK24_PATH); 
		res=updata_fontx(x+20*size/2,y,size,pname,3);	//GBK24.FON
		if(res){myfree(SRAMIN,pname);return 4;}
		//ȫº
		ftinfo.fontok=0XAA;
		W25QXX_Write((u8*)&ftinfo,FONTINFOADDR,sizeof(ftinfo));	//ֿϢ
	}
	myfree(SRAMIN,pname);//ͷڴ 
	myfree(SRAMIN,buf);
	return rval;//޴.			 
} 
//ʼ
//ֵ:0,ֿ.
//		 ,ֿⶪʧ
u8 font_init(void)
{		
	u8 t=0;
	W25QXX_Init();  
	while(t<10)//ȡ10,Ǵ,˵ȷʵ,øֿ
	{
		t++;
		W25QXX_Read((u8*)&ftinfo,FONTINFOADDR,sizeof(ftinfo));//ftinfoṹ
		if(ftinfo.fontok==0XAA)break;
		delay_ms(20);
	}
	if(ftinfo.fontok!=0XAA)return 1;
	return 0;		    
}





























